#include <arc/common.h>
#include <arc/resource.h>

Job::Job() : requested_cpu_time(UNDEFINED),
             requested_wall_time(UNDEFINED),
             queue_rank(UNDEFINED),
             submission_time(UNDEFINED),
             completion_time(UNDEFINED),
             used_cpu_time(UNDEFINED),
             used_wall_time(UNDEFINED),
             erase_time(UNDEFINED),
             used_memory(UNDEFINED),
             exitcode(UNDEFINED),
             cpu_count(UNDEFINED),
             proxy_expire_time(UNDEFINED),
             mds_validfrom(UNDEFINED),
             mds_validto(UNDEFINED) {
}


User::User() : free_diskspace(UNDEFINED),
               queue_length(UNDEFINED),
               mds_validfrom(UNDEFINED),
               mds_validto(UNDEFINED) {
}


Cluster::Cluster() : homogeneity(true),
                     cpu_freq(UNDEFINED),
                     node_memory(UNDEFINED),
                     total_cpus(UNDEFINED),
                     session_dir_free(UNDEFINED),
                     session_dir_total(UNDEFINED),
                     session_dir_lifetime(UNDEFINED),
                     cache_free(UNDEFINED),
                     cache_total(UNDEFINED),
                     total_jobs(UNDEFINED),
                     used_cpus(UNDEFINED),
                     queued_jobs(UNDEFINED),
                     mds_validfrom(UNDEFINED),
                     mds_validto(UNDEFINED) {
}


Queue::Queue() : running(UNDEFINED),
                 queued(UNDEFINED),
                 max_running(UNDEFINED),
                 max_queuable(UNDEFINED),
                 max_user_run(UNDEFINED),
                 max_cpu_time(UNDEFINED),
                 min_cpu_time(UNDEFINED),
                 default_cpu_time(UNDEFINED),
                 total_cpus(UNDEFINED),
                 cpu_freq(UNDEFINED),
                 node_memory(UNDEFINED),
                 grid_running(UNDEFINED),
                 grid_queued(UNDEFINED),
                 local_queued(UNDEFINED),
                 prelrms_queued(UNDEFINED),
                 mds_validfrom(UNDEFINED),
                 mds_validto(UNDEFINED) {
}


StorageElement::StorageElement() : free_space(UNDEFINED),
                                   total_space(UNDEFINED),
                                   mds_validfrom(UNDEFINED),
                                   mds_validto(UNDEFINED) {
}


ReplicaCatalog::ReplicaCatalog() : mds_validfrom(UNDEFINED),
                                   mds_validto(UNDEFINED) {
}

class HostRef {
    public:
        std::list<Job>::iterator j;
        std::string host;
};

void SortByHost(std::list<Job>& jobs) {
    std::list<HostRef> hosts;
    for(std::list<Job>::iterator jli = jobs.begin();jli!=jobs.end();) {
        std::list<HostRef>::iterator hi;
        for(hi = hosts.begin();hi!=hosts.end();++hi) {
            if(jli->cluster == hi->host) break;
        };
        if(hi==hosts.end()) {
            HostRef h;
            h.host=jli->cluster; h.j=jli; ++jli;
            continue;
        };
        hi->j=jobs.insert(++(hi->j),*jli);
        jli=jobs.erase(jli);
    };
}
